unit Unit1;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Preview;

type
  TForm1 = class(TForm)
    PrintPreview1: TPrintPreview;
    Panel1: TPanel;
    Button1: TButton;
    ComboBox1: TComboBox;
    Button2: TButton;
    Label1: TLabel;
    Label3: TLabel;
    Image1: TImage;
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PrintPreview1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
begin
  if PrintPreview1.State = psReady then
    PrintPreview1.Print;
  ActiveControl := PrintPreview1;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0: PrintPreview1.Zoom := 50;
    1: PrintPreview1.Zoom := 100;
    2: PrintPreview1.Zoom := 150;
    3: PrintPreview1.Zoom := 200;
    4: PrintPreview1.ZoomState := zsZoomToWidth;
    5: PrintPreview1.ZoomState := zsZoomToFit;
  end;
  ActiveControl := PrintPreview1;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I, FontSize: Integer;
  R: TRect;
begin
  Randomize;
  with PrintPreview1 do
  begin
    R := PageRect;
    BeginDoc;
    FontSize := Canvas.Font.Size;
    for I := 0 to 25 do
    begin
      Inc(FontSize, I);
      Canvas.Font.Size := FontSize;
      Canvas.Font.Color := RGB(Random(256), Random(256), Random(256));
      if (R.Top - Canvas.Font.Height) > PageRect.Bottom then
      begin
        NewPage;
        Canvas.Font.Size := FontSize;
        R := PageRect;
      end;
      R.Bottom := R.Top - Canvas.Font.Height;
      Canvas.TextRect(R, R.Left, R.Top, 'This is a sample text');
      R.Top := R.Bottom;
    end;
    NewPage;
    R.Left := (PaperWidth - Image1.Width) div 2;
    R.Right := (PaperWidth + Image1.Width) div 2;
    R.Top := (PaperHeight - Image1.Height) div 2;
    R.Bottom := (PaperHeight + Image1.Height) div 2;
    InflateRect(R, 15 * Image1.Width, 15 * Image1.Height);
    Canvas.StretchDraw(R, Image1.Picture.Graphic);
    EndDoc;
  end;
  ActiveControl := PrintPreview1;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 5;
end;

procedure TForm1.PrintPreview1Change(Sender: TObject);
begin
  if PrintPreview1.CurrentPage <> 0 then
  begin
    with PrintPreview1 do
      Label3.Caption := Format('Page %d of %d', [CurrentPage, TotalPages]);
    Label3.Update;
  end
  else
    Label3.Caption := 'Empty';
end;

end.
